// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2021-07-29T10:06:24, by ESR Version 2.4.43.0 using ESR Database SWS_EA_ESR_Cloud_Prod
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationRPTDPAIDTX
{

    public partial class RPTDPAIDTX2021Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// The report parameter
        /// </summary>
        private RPTDPAIDTX2021Request report;

        /// <summary>
        /// The response parameter
        /// </summary>
        public List<ProcessMessageDocument> response {get; private set;}

        /// <summary>
        /// Initializes a new instance of the <see cref="RPTDPAIDTX2021Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public RPTDPAIDTX2021Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
            this.response = new List<ProcessMessageDocument>();
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RPTDPAIDTX2021Validator" /> class.
        /// </summary>
        /// <param name="report">Report variable </param>                
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public RPTDPAIDTX2021Validator(RPTDPAIDTX2021Request reportIn, int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY"):this(maxParameterNameLength,maxParameterValueLength,emptyParameterValue)
        {                   
            this.ConsumedReport = reportIn;                    
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }

        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString().ToLower() : string.Empty;
        }

        private static string GetValueOrEmptyDate(DateTime? val)
        {
            return (val.HasValue) ? val.Value.ToString("yyyy-MM-dd") : string.Empty;
        }

        private static string GetValueOrEmptyDate(string val)
        {
            DateTime dateTimeOut;
            if (DateTime.TryParse(val, out dateTimeOut))
            {
                return dateTimeOut.ToString("yyyy-MM-dd");
            }
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmptyDateTime(string val)
        {
            DateTime dateTimeOut;
            if (DateTime.TryParse(val, out dateTimeOut))
            {
                return dateTimeOut.ToString("yyyy-MM-ddTHH:mm:ssZ");
            }
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmptyDateTime(DateTime? val)
        {
            return (val.HasValue) ? val.Value.ToString("yyyy-MM-ddTHH:mm:ssZ") : string.Empty;
        }

        private static string GetValueOrEmpty(string val)
        {
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(decimal? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(int? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

         /// <summary>
         /// Get string value between [first] a and [last] b.
         /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

         /// <summary>
         /// Get string value after [first] a.
         /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

         /// <summary>
         /// Get string value after [last] a.
         /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
            return 0;
            else
            return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return (from x in nodes select x).Distinct().Count() != 1;
        }

        private static bool HasDuplicateValues(IEnumerable<DateTime> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(IEnumerable<DateTime?> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool NotSameValues(IEnumerable<DateTime> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(IEnumerable<DateTime?> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
           if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

        public DateTime Date(DateTime? datetime)
        {                   
            return datetime.GetValueOrDefault().Date;
        }

				//The logic in After function expects "---" for day and "--" for month. 
				//Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
					return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response = true;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length == 14)
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 3), out numeric))
                        response = false;

                }
                else if (usi.Length == 9)
                {

                    if (Regex.IsMatch(usi, @"^([a-zA-Z]{3}\d{4}[a-zA-Z]{2})$"))
                        response = false;
                }
            }
            return response;
        }

        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
             return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
             decimal numberValue;
             decimal.TryParse(value, out numberValue);
             return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':                        
                        options = options | RegexOptions.IgnoreCase;                       
                        break;
                    case 'm':                        
                        options = options | RegexOptions.Multiline;                       
                        break;
                    case 's':                        
                            options = options | RegexOptions.Singleline;                       
                        break;
                    case 'n':                        
                            options = options | RegexOptions.ExplicitCapture;                       
                        break;
                    case 'x':                       
                            options = options | RegexOptions.IgnorePatternWhitespace;                       
                        break;
                }
            }

            return options;
        }

        private static string Substring(object field, int start, int length)
        {
            return field.ToString().Substring(start, length);
        }
        
        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public RPTDPAIDTX2021Request ConsumedReport { get {return report;} private set {report = value;}}

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string,ProcessMessageDocument>();				

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(RPTDPAIDTX2021Request reportIn)
        {
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = reportIn;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------
                VRATORPTDPAIDTX000001();
                VRATORPTDPAIDTX000002();
                VRATORPTDPAIDTX000003();
                VRATORPTDPAIDTX000004();
                VRATORPTDPAIDTX000005();
                VRATORPTDPAIDTX000006();
                VRATORPTDPAIDTX000007();
                VRATORPTDPAIDTX000008();
                VRATORPTDPAIDTX000009();
                VRATORPTDPAIDTX000010();
                VRATORPTDPAIDTX000011();
                VRATORPTDPAIDTX000012();

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }
				
			
    
      #region VR.ATO.RPTDPAIDTX.000001
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000001()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000001
            Where Intermediary is present, either the Intermediary Australian Business Number or Tax Agent Number must be provided
    
            Legacy Rule Format:
            (^RPTDPAIDTX100 <> NULL) AND (^RPTDPAIDTX101 = NULL) AND (^RPTDPAIDTX102 = NULL)

            Technical Business Rule Format:
            (^RPTDPAIDTX100 <> NULL) AND (^RPTDPAIDTX101 = NULL) AND (^RPTDPAIDTX102 = NULL)
    
            Data Elements:
    
            ^RPTDPAIDTX100 = RPTDPAIDTX:Int
    
            ^RPTDPAIDTX101 = RPTDPAIDTX:Int:Identifiers.AustralianBusinessNumber.Identifier
    
            ^RPTDPAIDTX102 = RPTDPAIDTX:Int:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.IntCollectionExists != false && report.RPTDPAIDTX101 == null && report.RPTDPAIDTX102 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000001", Severity = ProcessMessageSeverity.Error,
                    Description = @"Intermediary Australian Business Number or Tax Agent Number must be provided",
                    LongDescription = @"Where Intermediary is present, either the Intermediary Australian Business Number or Tax Agent Number must be provided",
                    Location = "/tns:RPTDPAIDTX/tns:Int",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000001"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX101", Value = GetValueOrEmpty(report.RPTDPAIDTX101) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX102", Value = GetValueOrEmpty(report.RPTDPAIDTX102) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000002
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000002()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000002
            The Intermediary Australian Business Number has failed the Australian business number algorithm check
    
            Legacy Rule Format:
            (^RPTDPAIDTX101 <> NULL) AND (FailsABNAlgorithm(^RPTDPAIDTX101))

            Technical Business Rule Format:
            (^RPTDPAIDTX101 <> NULL) AND (FailsABNAlgorithm(^RPTDPAIDTX101))
    
            Data Elements:
    
            ^RPTDPAIDTX101 = RPTDPAIDTX:Int:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.RPTDPAIDTX101 != null && FailsABNAlgorithm(report.RPTDPAIDTX101));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000002", Severity = ProcessMessageSeverity.Error,
                    Description = @"Intermediary Australian Business Number is invalid",
                    LongDescription = @"The Intermediary Australian Business Number has failed the Australian business number algorithm check",
                    Location = "/tns:RPTDPAIDTX/tns:Int/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000002"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX101", Value = GetValueOrEmpty(report.RPTDPAIDTX101) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000003
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000003()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000003
            The Tax Agent Number has failed the Tax Agent number algorithm check
    
            Legacy Rule Format:
            (^RPTDPAIDTX102 <> NULL) AND (FailsTANAlgorithm(^RPTDPAIDTX102))

            Technical Business Rule Format:
            (^RPTDPAIDTX102 <> NULL) AND (FailsTANAlgorithm(^RPTDPAIDTX102))
    
            Data Elements:
    
            ^RPTDPAIDTX102 = RPTDPAIDTX:Int:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.RPTDPAIDTX102 != null && FailsTANAlgorithm(report.RPTDPAIDTX102));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000003", Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax Agent Number is invalid",
                    LongDescription = @"The Tax Agent Number has failed the Tax Agent number algorithm check",
                    Location = "/tns:RPTDPAIDTX/tns:Int/tns:TaxAgentNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000003"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX102", Value = GetValueOrEmpty(report.RPTDPAIDTX102) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000004
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000004()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000004
            The Tax File Number has failed the Tax file number algorithm check
    
            Legacy Rule Format:
            (^RPTDPAIDTX111 <> NULL) AND (FailsTFNAlgorithm(^RPTDPAIDTX111))

            Technical Business Rule Format:
            (^RPTDPAIDTX111 <> NULL) AND (FailsTFNAlgorithm(^RPTDPAIDTX111))
    
            Data Elements:
    
            ^RPTDPAIDTX111 = RPTDPAIDTX:Rp:Identifiers.TaxFileNumber.Identifier
            */
            assertion = (report.RPTDPAIDTX111 != null && FailsTFNAlgorithm(report.RPTDPAIDTX111));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000004", Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax File Number is invalid",
                    LongDescription = @"The Tax File Number has failed the Tax file number algorithm check",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000004"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX111", Value = GetValueOrEmpty(report.RPTDPAIDTX111) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000005
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000005()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000005
            The reporting party's Tax File Number or Australian Business Number must be provided
    
            Legacy Rule Format:
            (^RPTDPAIDTX111 = NULL) AND (^RPTDPAIDTX112 = NULL)

            Technical Business Rule Format:
            (^RPTDPAIDTX111 = NULL) AND (^RPTDPAIDTX112 = NULL)
    
            Data Elements:
    
            ^RPTDPAIDTX111 = RPTDPAIDTX:Rp:Identifiers.TaxFileNumber.Identifier
    
            ^RPTDPAIDTX112 = RPTDPAIDTX:Rp:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.RPTDPAIDTX111 == null && report.RPTDPAIDTX112 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000005", Severity = ProcessMessageSeverity.Error,
                    Description = @"The reporting party's Tax File Number or Australian Business Number must be provided",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000005"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX111", Value = GetValueOrEmpty(report.RPTDPAIDTX111) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX112", Value = GetValueOrEmpty(report.RPTDPAIDTX112) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000006
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000006()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000006
            Either the reporting party's Tax File Number or Australian Business Number must be provided, but not both
    
            Legacy Rule Format:
            (^RPTDPAIDTX111 <> NULL) AND (^RPTDPAIDTX112 <> NULL)

            Technical Business Rule Format:
            (^RPTDPAIDTX111 <> NULL) AND (^RPTDPAIDTX112 <> NULL)
    
            Data Elements:
    
            ^RPTDPAIDTX111 = RPTDPAIDTX:Rp:Identifiers.TaxFileNumber.Identifier
    
            ^RPTDPAIDTX112 = RPTDPAIDTX:Rp:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.RPTDPAIDTX111 != null && report.RPTDPAIDTX112 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000006", Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax File Number and Australian Business Number must not both be provided",
                    LongDescription = @"Either the reporting party's Tax File Number or Australian Business Number must be provided, but not both",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000006"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX111", Value = GetValueOrEmpty(report.RPTDPAIDTX111) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX112", Value = GetValueOrEmpty(report.RPTDPAIDTX112) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000007
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000007()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000007
            The Australian Business Number has failed the Australian business number algorithm check
    
            Legacy Rule Format:
            (^RPTDPAIDTX112 <> NULL) AND (FailsABNAlgorithm(^RPTDPAIDTX112))

            Technical Business Rule Format:
            (^RPTDPAIDTX112 <> NULL) AND (FailsABNAlgorithm(^RPTDPAIDTX112))
    
            Data Elements:
    
            ^RPTDPAIDTX112 = RPTDPAIDTX:Rp:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.RPTDPAIDTX112 != null && FailsABNAlgorithm(report.RPTDPAIDTX112));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000007", Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian Business Number is invalid",
                    LongDescription = @"The Australian Business Number has failed the Australian business number algorithm check",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000007"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX112", Value = GetValueOrEmpty(report.RPTDPAIDTX112) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000008
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000008()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000008
            Payment Type code is invalid
    
            Legacy Rule Format:
            (NotInDomain(^RPTDPAIDTX113, 'Payment Types'))

            Technical Business Rule Format:
            (NotInDomain(^RPTDPAIDTX113, 'Payment Types'))
    
            Data Elements:
    
            ^RPTDPAIDTX113 = RPTDPAIDTX:Rp:Report.Type.Code
            */
            assertion = !(IsMatch(report.RPTDPAIDTX113, @"^(BTTP|TGGP|TP)$",RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000008", Severity = ProcessMessageSeverity.Error,
                    Description = @"Payment Type code is invalid",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:TypeC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000008"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX113", Value = report.RPTDPAIDTX113 });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000009
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000009()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000009
            The Period Start Date must not be earlier than 3 years prior to the 1st of July of the current financial year
    
            Legacy Rule Format:
            (^RPTDPAIDTX114 < ConvertToDate(1, 7, (CurrentFinancialYear() - 4)))

            Technical Business Rule Format:
            (^RPTDPAIDTX114 < ConvertToDate(1, 7, (CurrentFinancialYear() - 4)))
    
            Data Elements:
    
            ^RPTDPAIDTX114 = RPTDPAIDTX:Rp:Period.Start.Date
            */
            assertion = (report.RPTDPAIDTX114.GetValueOrDefault() < ConvertToDate(1, 7, CurrentFinancialYear() - 4));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000009", Severity = ProcessMessageSeverity.Error,
                    Description = @"Period Start Date is incorrect",
                    LongDescription = @"The Period Start Date must not be earlier than 3 years prior to the 1st of July of the current financial year",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:PeriodStartD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000009"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX114", Value = GetValueOrEmptyDate(report.RPTDPAIDTX114) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000010
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000010()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000010
            The Period End Date must not be prior to the Period Start Date
    
            Legacy Rule Format:
            (^RPTDPAIDTX115 < ^RPTDPAIDTX114)

            Technical Business Rule Format:
            ^RPTDPAIDTX115 < ^RPTDPAIDTX114
    
            Data Elements:
    
            ^RPTDPAIDTX115 = RPTDPAIDTX:Rp:Period.End.Date
    
            ^RPTDPAIDTX114 = RPTDPAIDTX:Rp:Period.Start.Date
            */
            assertion = (report.RPTDPAIDTX115.GetValueOrDefault() < report.RPTDPAIDTX114.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000010", Severity = ProcessMessageSeverity.Error,
                    Description = @"The Period End Date must not be prior to the Period Start Date",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:PeriodEndD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000010"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX115", Value = GetValueOrEmptyDate(report.RPTDPAIDTX115) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX114", Value = GetValueOrEmptyDate(report.RPTDPAIDTX114) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000011
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000011()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000011
            The requested reporting period must not exceed one year
    
            Legacy Rule Format:
            (^RPTDPAIDTX115 >= AddMonthsToDate(^RPTDPAIDTX114, 12))

            Technical Business Rule Format:
            (^RPTDPAIDTX115 >= AddMonthsToDate(^RPTDPAIDTX114, 12))
    
            Data Elements:
    
            ^RPTDPAIDTX115 = RPTDPAIDTX:Rp:Period.End.Date
    
            ^RPTDPAIDTX114 = RPTDPAIDTX:Rp:Period.Start.Date
            */
            assertion = (report.RPTDPAIDTX115.GetValueOrDefault() >= AddMonthsToDate(report.RPTDPAIDTX114.GetValueOrDefault(), 12));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000011", Severity = ProcessMessageSeverity.Error,
                    Description = @"The requested reporting period must not exceed one year",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:PeriodEndD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000011"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX115", Value = GetValueOrEmptyDate(report.RPTDPAIDTX115) });
    
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX114", Value = GetValueOrEmptyDate(report.RPTDPAIDTX114) });
    
                response.Add(processMessage);
            }
      }
      #endregion 
    
      #region VR.ATO.RPTDPAIDTX.000012
      [MethodImpl(MethodImplOptions.AggressiveInlining)]
      public virtual void VRATORPTDPAIDTX000012()
      {
        ProcessMessageDocument processMessage;
        bool assertion;
    
            /*  VR.ATO.RPTDPAIDTX.000012
            The Period End Date must not be a future date
    
            Legacy Rule Format:
            (^RPTDPAIDTX115 > Today())

            Technical Business Rule Format:
            (^RPTDPAIDTX115 > Today())
    
            Data Elements:
    
            ^RPTDPAIDTX115 = RPTDPAIDTX:Rp:Period.End.Date
            */
            assertion = (report.RPTDPAIDTX115.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.RPTDPAIDTX.000012", Severity = ProcessMessageSeverity.Error,
                    Description = @"The Period End Date must not be a future date",
                    Location = "/tns:RPTDPAIDTX/tns:Rp/tns:PeriodEndD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.RPTDPAIDTX.000012"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "RPTDPAIDTX115", Value = GetValueOrEmptyDate(report.RPTDPAIDTX115) });
    
                response.Add(processMessage);
            }
      }
      #endregion 

    }
} 
